Program GcpSim02;
{----------------------------------------------------------------}
{  Programmr    Bjrk Busch                                     }
{                11/03/92                                        }
{  Simulering af integrale-proces med Integrale-styring          }
{----------------------------------------------------------------}

 uses Dos, Crt;

Type
   ControlerDataType = Record
      Ki:          Real;        { Controlerkonstant  }
      Mn1:         Real;        { Controleroutput sidst }
   end;
   ProcesDataType = Record
      K:           Real;        { Proceskonstant     }
      Cn1:         Real;        { Procesoutput sidst }
   end;

Var
   ControlerData: ControlerDataType;
   ProcesData:    ProcesDataType;

{---------------------------------------------------------------}
{ Initiering af Controler ved opstart                           }
{---------------------------------------------------------------}
Procedure InitControler ( Var P: ControlerDataType; Ki: Real);
begin
   P.Ki  := Ki;         { Controlerkonstant            }
   P.Mn1 := 0;          { Controleroutput sidste gang  }
end;

{---------------------------------------------------------------}
{ Beregning af et controler-trin (ny output ved sampling)       }
{---------------------------------------------------------------}
Procedure Controler ( Var C: ControlerDataType;
                      En, T: Real; Var Mn: Real);
begin
   Mn := C.Mn1 + (C.Ki * T * En);
   C.Mn1 := Mn;   { Gem controleroutput til nste gang }
end;

{---------------------------------------------------------------}
{ Initiering af Proces ved opstart                              }
{---------------------------------------------------------------}
Procedure InitProces ( Var P: ProcesDataType; K: Real );
begin
   P.K   := K;          { Proceskonstant }
   P.Cn1 := 0;          { Procesoutput sidste gang  }
end;

{---------------------------------------------------------------}
{ Beregning af et proces-trin (ny output ved sampling)          }
{---------------------------------------------------------------}
Procedure Proces ( Var P: ProcesDataType;
                   Mn1, T: Real; Var Cn: Real);
begin
   Cn  := P.Cn1 + (P.K * T * Mn1);
   P.Cn1 := Cn;   { Gem proceoutput til nste gang }
end;

{---------------------------------------------------------------}
{ Display fejl                                                  }
{---------------------------------------------------------------}
Procedure DisplayFejl ( Sampling: Integer; Fejl: Real);
Var
   Iout:              Integer;
   x:                 Integer;

begin
   Write(Sampling:3);
   if ABS(Fejl) < 4 then begin
      Iout := 40+Round(Fejl*10);
      if Iout < 40 then begin
         for x := 1 to Iout do Write(' ');
         for x := x+1 to 39 do Write('-');
         Write('|');
      end
      else begin
         for x := 1 to 39 do Write(' ');
         Write('|');
         for x := 41 to Iout do Write('+');
      end;
   end
   else Write('Overflow');
   WriteLN;
end;

{---------------------------------------------------------------}
{  Hovedstyring                                                 }
{---------------------------------------------------------------}
Var
   Sampling:          Integer;
   AntalSampl:        Integer;
   SamplingsTid:      Real;
   Reference:         Real;          { nsket procesoutput }
   ControlerKonst:    Real;
   Fejl:              Real;
   ProcesKonst:       Real;          { Proceskonstant }
   ProcesInput:       Real;          { = Controleroutput }
   ProcesOutput:      Real;
   DataLog:           Text;

   Tast:              Char;

Begin
   ClrScr;
   ProcesKonst := 1;

   Write('Indtast samplingstid:     '); ReadLN(Samplingstid);
   Write('Indtast controlerkonstant:'); ReadLN(ControlerKonst);

   InitControler (ControlerData, ControlerKonst);
   InitProces (ProcesData, ProcesKonst);

   Assign(DataLog,'DataLog.PRN');
   Rewrite(DataLog);

   Reference    := 1;
   ProcesInput  := 0;

   Sampling     := 0;

   Repeat

      Proces (ProcesData ,ProcesInput, Samplingstid, ProcesOutput);

      Fejl := Reference - ProcesOutput;

      WriteLN(DataLog,Sampling:4,Reference:20,
                      ProcesInput:20,ProcesOutput:20,Fejl:20);

      DisplayFejl(Sampling, Fejl);

      Controler (ControlerData, Fejl, Samplingstid, ProcesInput);

      Sampling := Sampling + 1;

      Tast := ReadKey;

   Until Tast = #27;

   Close(DataLog);

End.
