Program SimulerIntegraleProces;

Type

   ProcesDataType = Record
      K:         Real;        { Proceskonstant     }
      Cn:        Real;        { Procesoutput       }
   end;


{-----------------------------------------------------------}
{ Initiering af Proces ved opstart                          }
{-----------------------------------------------------------}
Procedure InitProces ( Var P: ProcesDataType; K: Real );
begin
   P.K  := K;          { Proceskonstant }
   P.Cn := 0;         { Procesoutput   }
end;


{----------------------------------------------------------}
{ Beregning af et proces-trin (ny output ved sampling)     }
{----------------------------------------------------------}
Procedure Proces ( Var P: ProcesDataType;
                   Mn, T: Real; Var Cn: Real);
Var
   Mn_1:  Real;
   Cn_1:  Real;

begin
   Mn_1 := Mn;     { BEMRK der gr en sampling fr  }
                   { processen er slut og ny output  }
   Cn_1 := P.Cn;   { kan beregnes                    }

   Cn   := Cn_1 + (P.K * T * Mn_1);  { Beregn output }

   P.Cn := Cn;     { Gem proceoutput til nste gang }
end;

{-----------------------------------------------------------}
{  Simulering af proces med stepinput                       }
{-----------------------------------------------------------}
Var
   PData:       ProcesDataType;
   SamplTid:    Real;
   PKonst:      Real;          { Proceskonstant }
   PInput:      Real;          { = Controleroutput }
   POutput:     Real;
   Sampling:    Integer;
   AntalSampl:  Integer;
   StartPuls:   Integer;
   PulsLength:  Integer;
   DataLog:     Text;

Begin

   Assign(DataLog,'IntProc.PRN');
   Rewrite(DataLog);

   SamplTid   := 1.0;     { Tid mellem samplinger }
   POutput    := 0;
   PKonst     := 0.1;
   InitProces (PData, PKonst);

   StartPuls  := 3;
   PulsLength := 20;
   AntalSampl := 40;

   For Sampling := 0 to AntalSampl do begin

      if (Sampling >= StartPuls) AND
         (Sampling < StartPuls+PulsLength) then
          Pinput := 1
      else
          Pinput := 0;

      WriteLN(DataLog,Sampling:4, POutput:20, PInput:20);

      Proces (PData ,PInput, SamplTid, POutput);

   End;

   Close(DataLog);

End.
