Program SimulerProportionalProces;
Const
   Dmax = -3;         { index for max ddtid = -ddtid }
Type
   ProcesDataType = Record
      K:                  Real;    { Proceskonstant         }
      Dix:                Integer; { Ddtid index = -Ddtid }
      Mn: Array[Dmax..0] of Real;  { Procesinput            }
   end;
{-----------------------------------------------------------}
{ Initiering af Proces ved opstart                          }
{-----------------------------------------------------------}
Procedure InitProces ( Var P: ProcesDataType;
                       K: Real; D: Integer );
Var
   i: Integer;
begin
   P.K   := K;          { Proceskonstant }
   P.Dix := -D;         { Ddtid index   }
   For i := P.Dix to 0 do
      P.Mn[i] := 0;     { Procesinput }
end;

{----------------------------------------------------------}
{ Beregning af et proces-trin (ny output ved sampling)     }
{----------------------------------------------------------}
Procedure Proces ( Var P: ProcesDataType;
                   Mn: Real; Var Cn: Real);
Var
   i: Integer;
begin
   For i := P.Dix to -1 do    { BEMRK der gr en sampling }
      P.Mn[i] := P.Mn[i+1];   { fr processen er slut  og  }
   P.Mn[0] := Mn;             { ny output kan beregnes     }

   Cn  := P.K * P.Mn[P.Dix];            { Beregn ny output }

end;
{-----------------------------------------------------------}
{  Simulering af proces med stepinput                       }
{-----------------------------------------------------------}
Var
   PData:       ProcesDataType;
   SamplTid:    Real;
   DoedTid:     Real;
   PDoed:       Integer;
   PKonst:      Real;          { Proceskonstant }
   PInput:      Real;          { = Controleroutput }
   POutput:     Real;
   Sampling:    Integer;
   AntalSampl:  Integer;
   StartPuls:   Integer;
   PulsLength:  Integer;
   DataLog:     Text;
Begin
   Assign(DataLog,'ProDproc.PRN');
   Rewrite(DataLog);
   SamplTid   := 1.0;     { Tid mellem samplinger }
   POutput    := 0;
   PKonst     := 1.8;
   DoedTid    := 3.0;
   PDoed := Round(DoedTid/SamplTid);
   InitProces (PData, PKonst, PDoed);

   StartPuls  := 3;
   PulsLength := 20;
   AntalSampl := 40;
   For Sampling := 0 to AntalSampl do begin
      if (Sampling >= StartPuls) AND
         (Sampling < StartPuls+PulsLength) then
          Pinput := 1
      else
          Pinput := 0;
      WriteLN(DataLog,Sampling:4, POutput:20, PInput:20);
      Proces (PData ,PInput, POutput);
   End;
   Close(DataLog);
End.
