Program SimulerStyretSystem2;

Type
   SystemDataType = Record
      Cn: Array[-2..0] of Real; { Systemoutput for 3 trin }
   end;

{-----------------------------------------------------------}
{ Initiering af System ved opstart                          }
{-----------------------------------------------------------}
Procedure InitSystem ( Var S: SystemDataType );
begin
   S.Cn[0]  := 0;   { Systemoutput nu }
   S.Cn[-1] := 0;   { Systemoutput sidste gang }
   S.Cn[-2] := 0;   { Systemoutput 2 trin baglns }
end;

{----------------------------------------------------------}
{ Beregning af et system-trin (ny output ved sampling)     }
{----------------------------------------------------------}
Procedure System ( Var S: SystemDataType;
                   Rn: Real; Var Cn: Real);
Var
   Rn_1:  Real;
begin
   Rn_1 := Rn;           { BEMRK der gr en sampling }
   S.Cn[-2] := S.Cn[-1]; { fr processen er slut  og  }
   S.Cn[-1] := S.Cn[0];  { ny output kan beregnes     }

   Cn := S.Cn[-1] - S.Cn[-2] + Rn_1;  { Beregn ny output }

   S.Cn[0] := Cn;                  { Gem til senere brug }
end;

{-----------------------------------------------------------}
{  Simulering af styret system med proportionalcontrol      }
{-----------------------------------------------------------}
Var
   SData:       SystemDataType;
   Reference:   Real;          { = Systeminput }
   SOutput:     Real;
   Sampling:    Integer;
   AntalSampl:  Integer;
   DataLog:     Text;

Begin

   Assign(DataLog,'Datalog.PRN');
   Rewrite(DataLog);

   SOutput := 0;
   InitSystem (SData);

   WriteLN('Indtast antal nskede samplinger:');
   ReadLN(AntalSampl);

   For Sampling := 0 to AntalSampl do begin
      Write(Sampling,' Indtast referencevrdi:');
      ReadLN(Reference);
      WriteLN(DataLog, Sampling:4, SOutput:20, Reference:20);
      System (SData ,Reference, SOutput);
   End;

   Close(DataLog);

End.
